﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ReaderWriter
{   
    // form that shows buttons for opening, writing, and closing a file:
    public partial class WThread : Form
    {   private FileController c;  // we'll connect directly to the controller this time.
        private Writer file;       // handle to the file we will be writing, if any
        
        public WThread(FileController c)
        {   this.c = c;
            file = null;
            InitializeComponent();
        }

        // signals to open file and also to write lines into it
        private void button1_Click(object sender, EventArgs e)  {
            if (file == null ) {  // no file currently open?
                file = c.openWrite();
                if (file != null) {  // did we get the handle to the file ?
                    button1.Text = "Write";
                    textBox1.Text = "";
                    button2.Enabled = true;  // enable buttons to write and close file
                  }
                else { textBox1.Text = "Open Error; try again";  }
            }
            else  {  // file != null,  so write another line to it:
                file.writeLine(textBox1.Text);
                textBox1.Text = "";
           }
        }

        // signals to close file
        private void button2_Click(object sender, EventArgs e) {
          if (file != null) {
                c.close();
                file = null;
                button1.Text = "Open";
                textBox1.Text = "";
                button2.Enabled = false;
            }
        }

        private void WForm_Load(object sender, EventArgs e)
        {
            button2.Enabled = false;
        }
    }
}
